CUDA installation on Host Ubuntu 18.04 fails with Jetpack 4.4

Hi,

I am unable to install CUDA on my Ubuntu 18.04 Host PC and get the following error:

The following NEW packages will be installed:
  libcublas-dev
0 upgraded, 1 newly installed, 0 to remove and 150 not upgraded.
53 not fully installed or removed.
Need to get 0 B/42.3 MB of archives.
After this operation, 114 MB of additional disk space will be used.
Get:1 file:/var/cuda-repo-10-2-local-10.2.89-440.40  libcublas-dev 10.2.2.89-1 [42.3 MB]
(Reading database ... 
(Reading database ... 5%
(Reading database ... 10%
(Reading database ... 15%
(Reading database ... 20%
(Reading database ... 25%
(Reading database ... 30%
(Reading database ... 35%
(Reading database ... 40%
(Reading database ... 45%
(Reading database ... 50%
(Reading database ... 55%
(Reading database ... 60%
(Reading database ... 65%
(Reading database ... 70%
(Reading database ... 75%
(Reading database ... 80%
(Reading database ... 85%
(Reading database ... 90%
(Reading database ... 95%
(Reading database ... 100%
(Reading database ... 384984 files and directories currently installed.)
Preparing to unpack .../libcublas-dev_10.2.2.89-1_amd64.deb ...
Unpacking libcublas-dev (10.2.2.89-1) ...
dpkg: error processing archive /var/cuda-repo-10-2-local-10.2.89-440.40/./libcublas-dev_10.2.2.89-1_amd64.deb (--unpack):
 trying to overwrite '/usr/include/cublas_v2.h', which is also in package nvidia-cuda-dev 9.1.85-3ubuntu1
dpkg-deb: error: paste subprocess was killed by signal (Broken pipe)

It seems the existing CUDA 9 version conflicts with the 10.2 installation. Is there a way to resolve this in a straightforward manner?

Thanks,
S

P.S.: SDK Manager Logs are attached here (remove the trailing .txt and unzip) SDKM_logs_JetPack_4.4_DP_Linux_2020-06-08_12-50-35.zip.txt (117.4 KB)

Are you trying to use a JetPack/SDK Manager release to install recent CUDA on a system which was flashed with an earlier release? If so, then it won’t work as there are strong dependencies between the rest of the operating system and the CUDA release. For that case you would also have to flash the system to have compatible CUDA and L4T/JetPack/SDKM releases.

Yes. I had CUDA 9 installed on the system with Jetpack 4.3.1 and was trying to install Jetpack 4.4 with CUDA 10.2. AFAIK multiple CUDA versions on the same system are not a problem.

Anyway, I reverted back to Jetpack 4.3.1 with L4T 32.3.1. Now, however I have changed the install path in SDK Manager for the target (because I don’t have enough space in my home partition). Now, everything breaks!

Here is an extract of one error log:

  • 10:56:43 INFO : Drivers for Jetson AGX : verifying checksum of /home/imperiumdrive/Downloads/nvidia/sdkm_downloads/Jetson_Linux_R32.3.1_aarch64.tbz2
  • 10:56:47 INFO : Drivers for Jetson AGX : Found file /home/imperiumdrive/Downloads/nvidia/sdkm_downloads/Jetson_Linux_R32.3.1_aarch64.tbz2 with correct checksum, skip downloading.
  • 10:56:47 INFO : Drivers for Jetson AGX : Download ‘Drivers for Jetson AGX’ success
  • 10:56:47 INFO : Drivers for Jetson AGX : Start to install ‘Drivers for Jetson AGX’
  • 10:56:47 DEBUG : Drivers for Jetson AGX : using adapter to install NV_L4T_DRIVERS_T194_COMP@JETSON_AGX_XAVIER to /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER
  • 10:56:47 INFO : Drivers for Jetson AGX : [ Disk Avail:31.62 GB ]
  • 10:56:47 INFO : Drivers for Jetson AGX : Using GenericInstaller to Install NV_L4T_DRIVERS_T194_COMP
  • 10:56:47 INFO : Drivers for Jetson AGX : NV_L4T_DRIVERS_T194_COMP include 1 package
  • 10:56:47 INFO : Drivers for Jetson AGX : change working directory to /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER
  • 10:56:47 INFO : Drivers for Jetson AGX : [ Package PreInstall Started ]
  • 10:56:47 INFO : Drivers for Jetson AGX : current working directory is /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER
  • 10:56:47 INFO : Drivers for Jetson AGX : exec_command: sudo rm -rf /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER/Linux_for_Tegra/
  • 10:56:47 INFO : Drivers for Jetson AGX : [host] [sudo] password for imperiumdrive:
  • 10:56:47 INFO : Drivers for Jetson AGX :
  • 10:56:47 INFO : Drivers for Jetson AGX : [ Package PreInstall Finished Successfully ]
  • 10:56:47 INFO : Drivers for Jetson AGX : [ Package Install Started ]
  • 10:56:47 INFO : Drivers for Jetson AGX : current working directory is /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER
  • 10:56:47 INFO : Drivers for Jetson AGX : exec_command [host]:
  • 10:56:47 INFO : Drivers for Jetson AGX : **********************
  • 10:56:47 INFO : Drivers for Jetson AGX : #!/bin/bash
  • 10:56:47 INFO : Drivers for Jetson AGX : set -e
  • 10:56:47 INFO : Drivers for Jetson AGX :
  • 10:56:47 INFO : Drivers for Jetson AGX : function safe_apt_install {
  • 10:56:47 INFO : Drivers for Jetson AGX : echo “*begin $1, $2”
  • 10:56:47 INFO : Drivers for Jetson AGX : tmp_log=/tmp/jetpack_dpkg_log.txt
  • 10:56:47 INFO : Drivers for Jetson AGX : sudo rm -f $tmp_log
  • 10:56:47 INFO : Drivers for Jetson AGX : set +e; $1 2>&1 | tee tmp_log; CMD_STATUS={PIPESTATUS[0]}; set -e
  • 10:56:47 INFO : Drivers for Jetson AGX : while [ ${CMD_STATUS} -ne 0 ]; do
  • 10:56:47 INFO : Drivers for Jetson AGX : if grep -q -e “is locked by another process” -e “E: Could not get lock /var/lib” $tmp_log; then
  • 10:56:47 INFO : Drivers for Jetson AGX : sudo rm -f $tmp_log
  • 10:56:47 INFO : Drivers for Jetson AGX : set +e; $1 2>&1 | tee tmp_log; CMD_STATUS={PIPESTATUS[0]}; set -e
  • 10:56:47 INFO : Drivers for Jetson AGX : echo "Waiting 2 seconds for apt to be available"; sleep {2}
  • 10:56:47 INFO : Drivers for Jetson AGX : else
  • 10:56:47 INFO : Drivers for Jetson AGX : echo “Unhandled error when running $1”; exit 1
  • 10:56:47 INFO : Drivers for Jetson AGX : fi
  • 10:56:47 INFO : Drivers for Jetson AGX : done
  • 10:56:47 INFO : Drivers for Jetson AGX : }
  • 10:56:47 INFO : Drivers for Jetson AGX : sudo apt-get update || true
  • 10:56:47 INFO : Drivers for Jetson AGX : safe_apt_install “sudo apt-get install -y pigz lbzip2” 5
  • 10:56:47 INFO : Drivers for Jetson AGX : tar xpf /home/imperiumdrive/Downloads/nvidia/sdkm_downloads/Jetson_Linux_R32.3.1_aarch64.tbz2
  • 10:56:47 INFO : Drivers for Jetson AGX : **********************
  • 10:56:47 INFO : Drivers for Jetson AGX : exec_command: /tmp/tmp_NV_L4T_DRIVERS_T194_COMP.sh
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:1 file:/var/cuda-repo-10-2-local-10.2.89-440.40 InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Ign:1 file:/var/cuda-repo-10-2-local-10.2.89-440.40 InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:2 file:/var/visionworks-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Ign:2 file:/var/visionworks-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:3 file:/var/visionworks-sfm-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Ign:3 file:/var/visionworks-sfm-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:4 file:/var/visionworks-tracking-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Ign:4 file:/var/visionworks-tracking-repo InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:5 file:/var/cuda-repo-10-2-local-10.2.89-440.40 Release [574 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:5 file:/var/cuda-repo-10-2-local-10.2.89-440.40 Release [574 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:6 file:/var/visionworks-repo Release [1,999 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:6 file:/var/visionworks-repo Release [1,999 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:7 file:/var/visionworks-sfm-repo Release [2,003 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:7 file:/var/visionworks-sfm-repo Release [2,003 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:8 file:/var/visionworks-tracking-repo Release [2,008 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:8 file:/var/visionworks-tracking-repo Release [2,008 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:9 file:/var/visionworks-repo Release.gpg [819 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Get:9 file:/var/visionworks-repo Release.gpg [819 B]
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:10 http://ppa.launchpad.net/freecad-maintainers/freecad-stable/ubuntu bionic InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:11 http://security.ubuntu.com/ubuntu bionic-security InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:12 http://packages.microsoft.com/repos/vscode stable InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:13 http://de.archive.ubuntu.com/ubuntu bionic InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:14 http://ppa.launchpad.net/webupd8team/java/ubuntu bionic InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:15 http://dl.google.com/linux/chrome/deb stable InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:16 http://de.archive.ubuntu.com/ubuntu bionic-updates InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:17 http://packages.cloud.google.com/apt cloud-sdk-bionic InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:18 https://packages.microsoft.com/ubuntu/19.10/prod eoan InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:19 http://de.archive.ubuntu.com/ubuntu bionic-backports InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:23 http://packages.ros.org/ros/ubuntu bionic InRelease
  • 10:56:48 INFO : Drivers for Jetson AGX : Hit:24 http://packages.ros.org/ros2/ubuntu bionic InRelease
  • 10:56:50 INFO : Drivers for Jetson AGX : Hit:25 https://packagecloud.io/slacktechnologies/slack/debian jessie InRelease
  • 10:56:53 INFO : Drivers for Jetson AGX : Reading package lists…
  • 10:56:53 INFO : Drivers for Jetson AGX : *begin sudo apt-get install -y pigz lbzip2, 5
  • 10:56:53 INFO : Drivers for Jetson AGX : Reading package lists…
  • 10:56:53 INFO : Drivers for Jetson AGX : Building dependency tree…
  • 10:56:53 INFO : Drivers for Jetson AGX : Reading state information…
  • 10:56:53 INFO : Drivers for Jetson AGX : lbzip2 is already the newest version (2.5-2).
  • 10:56:53 INFO : Drivers for Jetson AGX : pigz is already the newest version (2.4-1).
  • 10:56:53 INFO : Drivers for Jetson AGX : You might want to run ‘apt --fix-broken install’ to correct these.
  • 10:56:53 INFO : Drivers for Jetson AGX : The following packages have unmet dependencies:
  • 10:56:53 INFO : Drivers for Jetson AGX : cuda-libraries-dev-10-2 : Depends: libcublas-dev (>= 10.2.2.89) but it is not going to be installed
  • 10:56:53 INFO : Drivers for Jetson AGX : cuda-samples-10-2 : Depends: libcublas-dev (>= 10.2.2.89) but it is not going to be installed
  • 10:56:53 INFO : Drivers for Jetson AGX : cuda-visual-tools-10-2 : Depends: libcublas-dev (>= 10.2.2.89) but it is not going to be installed
  • 10:56:54 INFO : Drivers for Jetson AGX : E: Unmet dependencies. Try ‘apt --fix-broken install’ with no packages (or specify a solution).
  • 10:56:54 INFO : Drivers for Jetson AGX : Unhandled error when running sudo apt-get install -y pigz lbzip2
  • 10:56:54 ERROR : Drivers for Jetson AGX : [exec_command]: /bin/bash -c /tmp/tmp_NV_L4T_DRIVERS_T194_COMP.sh; [error]: exit status 1
  • 10:56:54 INFO : Drivers for Jetson AGX : [ Package Install Finished with Error ]
  • 10:56:54 INFO : Drivers for Jetson AGX : [ 16.00 KB used. Disk Avail: 31.62 GB ]
  • 10:56:54 INFO : Drivers for Jetson AGX : [ NV_L4T_DRIVERS_T194_COMP Install took 6s ]
  • 10:56:54 ERROR : Drivers for Jetson AGX : [error]: Run commands failed at step Install: command /tmp/tmp_NV_L4T_DRIVERS_T194_COMP.sh finished with error
  • 10:56:54 INFO : Drivers for Jetson AGX :
  • 10:56:54 ERROR : Drivers for Jetson AGX : command terminated with error
  • 10:56:54 ERROR : Drivers for Jetson AGX : Install ‘Drivers for Jetson AGX’ failure, command < using adapter to install NV_L4T_DRIVERS_T194_COMP@JETSON_AGX_XAVIER to /data/nvidia/nvidia_sdk/JetPack_4.3_Linux_JETSON_AGX_XAVIER > terminated with error.

INSTALLATION FAILED
Please review the terminal tab for details. Resolve and RETRY.

Full logs are attached.

SDKM_logs_JetPack_4.3_Linux_for_Jetson_AGX_Xavier_2020-06-10_10-56-38.zip.txt (96.5 KB) Thanks in advance for your help.

I think all the errors stem from the failed CUDA 10 installation:

CUDA on Host : trying to overwrite '/usr/include/cublas_v2.h', which is also in package nvidia-cuda-dev 9.1.85-3ubuntu1

How can I fix this?

I don’t know about this particular case, but sometimes this will allow continuing if there is a dependency issue:

sudo apt update
sudo apt --fix-broken install

…then try again.

No, the issue is that CUDA 9 is preventing an update to CUDA 10:

dpkg: error processing archive /var/cuda-repo-10-2-local-10.2.89-440.40/./libcublas-dev_10.2.2.89-1_amd64.deb (--unpack):
 trying to overwrite '/usr/include/cublas_v2.h', which is also in package nvidia-cuda-dev 9.1.85-3ubuntu1

Funny thing is I do have CUDA 10 as seen in nvidia-smi.

You could uninstall CUDA 9 first, and then try. On non-package based installs more than one release of CUDA can exist, but I’m not sure on Ubuntu via package based install (I work on Fedora for the host PC).

NOTE: nvidia-smi is a PCI query tool to look for GPUs. Perhaps there is an issue in finding a compatible GPU, although this seems unlikely. So far as I know nvidia-smi is most likely telling you the hardware supports CUDA 10, and not that CUDA 10 is installed…not sure.